# Concept for Realtime Plotting of a Servo
This concept was to develop a structured plotting scheme and was not updated after implementing it.
So it might be useful to understand the implementation, but it isn't completely correct.

## User Story

### Terminal

#### Ramp
* Start a ramp with some parameters.
  * The parameters will be saved in the object.
  * Possible to reenable the same ramp.
* Extra parameter to start saving data to fifo.

#### Continuous Data
* Enable the fifo data and define the interval.
* Start the plotting (maybe only one command?)

#### Realtime Plotting
* Enable plotting with the defined interval.
* _Optional: Ability to change parameters while plotting._

### Dash
TODO

## Implementation

### Take Data
* Take number of requested entries for all 3 channels, max the size of the current adwin buffer.
* Return as a `DataContainer`.

### Prepare continuous Data
* Take number of entries of the fifo buffer.
* Delete oldest entries to stay at `maxlen`.

### Prepare ramp Data
* Take data.
* Find the first entry in `output` that contains the minimum value.
* Save the data from that index on and fill up with new taken data.
  * Wait a time that it should be filled.
  * Request number of data to fill.
  * Local value of `maxlen` should not be larger than the fifo buffer size of adwin to avoid the need of looping.

### Update the Graph
* Take periodically the data and update the graph.
* Period is automatically calculated: 
  * Sleep a time to fill half of the fifo buffer.  
    `TODO` How much can we increase it? 
  * Maximal resulting framerate should be about 30 Hz.

### Triggering the Ramp
The output of the ramp on ADwin is based on a digital calculation.
Therefore it is absolutely reproducible without any variances.

#### Find the precice Value of the Minimum
Take data of at least a whole ramp and find the minimum.

* Need a saving frequency that matches to the current ramp.
* Check that the precice value of the minimum is nearly the negative ramp amplitude.
