'<ADbasic Header, Headerversion 001.001>
' Process_Number                 = 1
' Initial_Processdelay           = 1000
' Eventsource                    = Timer
' Control_long_Delays_for_Stop   = No
' Priority                       = High
' Version                        = 1
' ADbasic_Version                = 6.2.0
' Optimize                       = Yes
' Optimize_Level                 = 3
' Stacksize                      = 1000
' Info_Last_Save                 = X220  X220\adwin
'<Header End>
#Include ADwinPro_All.inc
#Include .\filter_module.inc
Import Math.lic

#Define AIN_MODULE_1 1
#Define AIN_MODULE_2 2
#Define AOUT_MODULE_1 3
#Define AOUT_MODULE_2 4
#Define NUM_INPUT_CHANNELS 8
#Define NUM_OUTPUT_CHANNELS 8
#Define NUM_ADC_CHANNELS 16
#Define NUM_DAC_CHANNELS 16
#Define CPU_CLK 1000000000
#Define PROC_CLK 200000
#Define FIFO_BUFFER_SIZE 10003
#Define NUM_RAMP_VALUES 131072
#Define TTL_HIGH 0C000h  ' +5V
#Define TTL_LOW 8000h   ' 0V

#Define timer PAR_1
' monitor control Parameter, values from 1 to 8
#Define monitor_sel Data_6
Dim monitor_sel[NUM_FILTERS] as Long
' TTL
Dim TTL_current as Long
#Define TTL_DIG_CHANNEL 0
' Ramp Control Register
#Define rcr Par_3
' Ramp amplitude. 1 means ±10V
#Define ramp_amplitude FPar_1
'ramp Data array
Dim ramp_data[NUM_RAMP_VALUES], ramp_idx, ramp_chan as Long

Dim timer_last, timer_now, t1, t2, new_time As Long

' The inputs straight from the ADC
Dim adc_input[NUM_ADC_CHANNELS] As Long
' The outputs straight into the DAC
Dim dac_output[NUM_DAC_CHANNELS] As Long

#Define input_sensitivity Par_8
Dim input_sensitivity_last as Long

#Define fifo_data Data_3
#Define fifo_sel Par_4
#Define fifo_counter_max Par_6
Dim fifo_data[FIFO_BUFFER_SIZE] as Float as FIFO
Dim fifo_counter = 1 as Long at Dm_Local

#Define last_output Data_4
Dim last_output[NUM_FILTERS] as Long

Dim i as long
Dim ADCF_Mode as Long


Sub Blinkenlights()
  Dim even_odd as Long
  timer_now = Read_Timer()
  If ((timer_now - timer_last) > CPU_CLK) Then
    Inc(timer)
    even_odd = Mod(timer, 2)
    P2_Set_Led(AIN_MODULE_1, even_odd)
    P2_Set_Led(AOUT_MODULE_1, even_odd)
    P2_Set_Led(AIN_MODULE_2, 1-even_odd)
    P2_Set_Led(AOUT_MODULE_2, 1-even_odd)
    timer_last = timer_now
  EndIf
EndSub

Sub SetInputSensitivity()
  Dim inputMode as long
  Dim auxMode as long

  if (input_sensitivity_last <> input_sensitivity) then
    For i=1 to NUM_INPUT_CHANNELS
      inputMode = Shift_Right(input_sensitivity And Shift_Left(3, 2*i-2), 2*i-2)
      auxMode = Shift_Right(input_sensitivity And Shift_Left(3, 2*i+14), 2*i+14)

      P2_Set_Gain(AIN_MODULE_1, i, inputMode)
      P2_Set_Gain(AIN_MODULE_2, i, auxMode)
    next i
    input_sensitivity_last = input_sensitivity
  endif
EndSub

Sub SendToMonitors()
  Dim mon as Long
  for mon=1 to NUM_INPUT_CHANNELS
    If (monitor_sel[mon] > 0) Then
      If (monitor_sel[mon] > 20) Then
        If (monitor_sel[mon] < 29) Then
          ' Output signal
          dac_output[mon+NUM_OUTPUT_CHANNELS] = dac_output[monitor_sel[mon]-20]
        Else
          ' TTL signal
          dac_output[mon+NUM_OUTPUT_CHANNELS] = TTL_current
        EndIf
      Else
        ' Input and aux signal
          dac_output[mon+NUM_OUTPUT_CHANNELS] = adc_input[monitor_sel[mon]]
      EndIf
    EndIf
  next mon
EndSub

Sub SendToFifo()
  Dim combined as Float
  If (fifo_sel > 0 ) Then
    If (fifo_counter >= fifo_counter_max) Then ' There is a `&&` or `AndAlso` operator missing...
      ' send values for current channel to PC
      ' Note: we do this before filters, as filters do calculations on adc_input
      ' We want to ensure a fixed phase between the channels.
      ' Therefore we combine all in one fifo array field.

      ' Saving 3 16bit channels in a 64bit long variable
      ' Byte    | 7 6 | 5 4   | 3 2 | 1 0    |
      ' Channel |     | input | aux | output |

      combined = (adc_input[fifo_sel]) * 4294967296 ' This number is 2^32 and is a workaround for Shift_Left, which is not working for results > 32bit
      combined = combined + Shift_Left(adc_input[fifo_sel+8], 16)
      combined = combined + dac_output[fifo_sel]

      fifo_data = combined

      fifo_counter = 0
    EndIf
    fifo_counter = fifo_counter + 1
  EndIf
EndSub

Sub RunRamp()
  ramp_chan = rcr And 0fh
  If (ramp_chan > 0) Then
    dac_output[ramp_chan] = (ramp_data[ramp_idx] * ramp_amplitude) + 8000h
    ramp_idx = ramp_idx + Shift_Right(rcr And 0ff00h, 8)
    If (ramp_idx > NUM_RAMP_VALUES) Then
      ramp_idx = 1
      CPU_Digout(TTL_DIG_CHANNEL, 1)  ' TTL high
      TTL_current = TTL_HIGH
    Else
      CPU_Digout(TTL_DIG_CHANNEL, 0)  ' TTL low
      TTL_current = TTL_LOW
    EndIf
  EndIf
EndSub

Sub LimitToOutputRange()
  Dim iij as Long
  'setting values which are above 65535 or below 0 to the maximum(65535) respectively minimum value(0) of the P2_Write_DAC8 command,
  'since it only takes the last 16 bits of integers out of its boundaries
  for iij=1 to NUM_DAC_CHANNELS
    if (dac_output[iij]>65535) then
      dac_output[iij]=65535
    endif
    if (dac_output[iij]<0) then
      dac_output[iij]=0
    endif
  next iij
EndSub

Sub UpdateLastOutput()
  for i=1 to NUM_FILTERS
    last_output[i] = dac_output[i]
  next i
  ' Alternative:
  ' P2_Write_DAC8(last_output, dac_output, 1)
EndSub


Init:
  Processdelay = CPU_CLK/PROC_CLK ' 200 KHz
  'setting the values of the filter control register to zero
  Par_11=0
  Par_12=0
  Par_13=0
  Par_14=0
  Par_15=0
  Par_16=0
  Par_17=0
  Par_18=0
  'prepoluate dac_output

  input_sensitivity = 0
  input_sensitivity_last = 1
  timer = 0
  timer_last = Read_Timer()
  ramp_chan = 0

  Fifo_Clear(3)

  CPU_Dig_IO_Config(110011b)

  ' TODO nicer?
  for i=1 to 8
    monitor_sel[i] = 0
  next i

  'populates ramp_data with the values from -10V to 10V
  For ramp_idx = 0 To 0ffffh
    ramp_data[ramp_idx+1] = ramp_idx - 8000h
    ramp_data[20000h-ramp_idx] = ramp_data[ramp_idx+1]
  Next ramp_idx
  ramp_idx = 1

  P2_Set_Average_Filter(AIN_MODULE_1, 0) ' use 5 to average 32 measurements

  ' Pseudo code:
  ' ADCF_Mode = 2^(AIN_MODULE_1-1) + 2^(AIN_MODULE_2-1)
  ADCF_Mode = Shift_Left(1, AIN_MODULE_1-1) + Shift_Left(1, AIN_MODULE_2-1)

  P2_ADCF_Mode(ADCF_Mode, 1)   ' Enable Timer mode on Module 2 & 3 (bit flag for module address!)


Event:
  t1 = Read_Timer()

  ' Start DAC conversion on all DACs simultaneously
  P2_Sync_All(Shift_Left(1, AOUT_MODULE_1-1) Or Shift_Left(1, AOUT_MODULE_2-1))

  ' Read in values from ADC modules, these have already been converted because of the
  ' ADCF timer mode
  P2_Read_ADCF8(AIN_MODULE_1, adc_input, 1)
  P2_Read_ADCF8(AIN_MODULE_2, adc_input, 9)

  SendToMonitors()

  SendToFifo()

  RunFilters(adc_input, dac_output)

  RunRamp()

  LimitToOutputRange()

  UpdateLastOutput()

  ' pre-populate DACs with new values
  P2_Write_DAC8(AOUT_MODULE_1, dac_output, 1)
  P2_Write_DAC8(AOUT_MODULE_2, dac_output, 9)

  Blinkenlights()

  SetInputSensitivity()

  t2 = Read_Timer()
  new_time = t2 - t1 -4
  Par_7 = new_time

Finish:
  ' Switch off LEDs
  P2_Set_Led(AIN_MODULE_1, 0)
  P2_Set_Led(AIN_MODULE_2, 0)
  P2_Set_Led(AOUT_MODULE_1, 0)
  P2_Set_Led(AOUT_MODULE_2, 0)
